﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;
using System.Diagnostics;
using System.Threading;
using System.Collections;
using Infragistics.Win.UltraActivityIndicator;
using Infragistics.Win;


namespace UltraComboWithDependedCombo
{
    public partial class Form1 : Form
    {
        private BackgroundWorker backgroundWorker1;

        private DataTable dt1;
        private DataTable dt2;


        public Form1()
        {
            InitializeComponent();

            ultraCombo2.CreationFilter = new ProgressUIElement();

            ultraCombo1.Enabled = false;
            ultraCombo2.Enabled = false;
            this.backgroundWorker1 = new BackgroundWorker();
            backgroundWorker1.DoWork += new DoWorkEventHandler(backgroundWorker1_DoWork);
            backgroundWorker1.RunWorkerCompleted += new RunWorkerCompletedEventHandler(backgroundWorker1_RunWorkerCompleted);
            this.backgroundWorker1.RunWorkerAsync();
        }

        void backgroundWorker1_RunWorkerCompleted(object sender, RunWorkerCompletedEventArgs e)
        {
            ultraCombo1.Enabled = true;
            ultraCombo2.Enabled = true;
            ultraCombo1.DataSource = dt1;
            ultraCombo1.DisplayMember = "Description";
            ultraCombo1.ValueMember = "Description";
        }

        void backgroundWorker1_DoWork(object sender, DoWorkEventArgs e)
        {
            dt1 = new DataTable();
            dt1.Columns.Add("ID", typeof(int));
            dt1.Columns.Add("Description", typeof(string));

            dt2 = new DataTable();
            dt2.Columns.Add("PID", typeof(int));
            dt2.Columns.Add("Value", typeof(string));


            for (int i = 0; i < 100000; i++)
            {
                dt1.Rows.Add(i, "Item " + i.ToString());

                for (int k = 0; k < 40; k++)
                {
                    dt2.Rows.Add(i, "Test " + i.ToString() + " - " + k.ToString());
                }
            }

        }


        delegate void LoadDelegate(object dd);
        private void ultraCombo2_BeforeDropDown(object sender, CancelEventArgs e)
        {
           

            Thread thread = new Thread(new ThreadStart(LoadItems));
            thread.Start();
        }

        public void LoadItems()
        {
            LoadItems(null);
        }

        public void LoadItems(object gr)
        {
            if (this.InvokeRequired)
            {
                var shortlist = from q in dt2.Rows.Cast<DataRow>()
                                   where q[0].ToString() == ultraCombo1.SelectedRow.Cells[0].Text
                                   select new
                                   {
                                       PID = q[0],
                                       Value = q[1]
                                   };

                LoadDelegate del = new LoadDelegate(LoadItems);
                this.Invoke(del, new object [] { shortlist.ToList() });
            }
            else
            {
                ProgressUIElement.indicator.Visible = false;
                ultraCombo2.DataSource = gr;
                ultraCombo2.DisplayMember = "Value";
                ultraCombo2.ValueMember = "Value";
                ultraCombo2.ReadOnly = false;
                //ultraCombo2.DisplayLayout.Bands[0].Columns["Value"].Width = 100;
                ultraCombo2.DisplayLayout.AutoFitStyle = AutoFitStyle.ResizeAllColumns;
                
            }

        }

        private void ultraCombo2_AfterDropDown(object sender, EventArgs e)
        {
            ultraCombo2.ReadOnly = true;
            ultraCombo2.DataSource = null;
            ProgressUIElement.indicator.Visible = true;
        }
    }

    public class ProgressUIElement : IUIElementCreationFilter
    {
        public static UltraActivityIndicator indicator = new UltraActivityIndicator();
        public void AfterCreateChildElements(UIElement parent)
        {
            DataAreaUIElement El = parent as DataAreaUIElement;
            if (El != null)
            {
                indicator.Parent = El.Control;
                indicator.AnimationEnabled = true;
                indicator.MarqueeMarkerWidth = 40;
                indicator.AnimationSpeed = 20;
                indicator.AnimationEnabled = true;
                indicator.MarqueeAnimationStyle = MarqueeAnimationStyle.BounceBack;
                indicator.Size = new System.Drawing.Size(El.Rect.Width - 20, 12);
                indicator.Location = new Point(El.Rect.X + 10 , El.Rect.Y + 8 );
            }
        }


        public bool BeforeCreateChildElements(UIElement parent)
        {
            return false;
        }
    }

}
